=== modified file 'debian/ubiquity.install-any'
--- debian/ubiquity.install-any	2010-03-09 09:46:07 +0000
+++ debian/ubiquity.install-any	2010-04-08 13:58:29 +0000
@@ -1,6 +1,6 @@
 ubiquity/*.py usr/lib/ubiquity/ubiquity
+ubiquity/plugins/*.py usr/lib/ubiquity/plugins
 ubiquity/components/__init__.py usr/lib/ubiquity/ubiquity/components
-ubiquity/components/ubi-summary.py usr/lib/ubiquity/plugins
 ubiquity/components/install.py usr/lib/ubiquity/ubiquity/components
 ubiquity/frontend/__init__.py usr/lib/ubiquity/ubiquity/frontend
 ubiquity/frontend/base.py usr/lib/ubiquity/ubiquity/frontend
@@ -43,7 +43,6 @@
 # console-setup
 compat/locale usr/lib/ubiquity/console-setup
 scripts/console-setup-apply usr/lib/ubiquity
-ubiquity/components/ubi-console-setup.py usr/lib/ubiquity/plugins
 debian/kbdnames.gz usr/share/console-setup-mini
 d-i/source/console-setup/Keyboard/pc105.tree usr/lib/ubiquity/console-setup
 
@@ -72,37 +71,29 @@
 d-i/source/localechooser/debian/localechooser/usr/share/localechooser/languagelist.data.gz usr/lib/ubiquity/localechooser
 d-i/source/localechooser/regionmap usr/lib/ubiquity/localechooser
 d-i/source/localechooser/debian/short-tmp/shortlists usr/lib/ubiquity/localechooser
-ubiquity/components/ubi-language.py usr/lib/ubiquity/plugins
 scripts/localechooser-apply usr/lib/ubiquity
 
 # netcfg
 d-i/source/netcfg/netcfg usr/lib/ubiquity/netcfg
 scripts/netcfg-wrapper usr/lib/ubiquity
-ubiquity/components/ubi-network.py usr/lib/ubiquity/plugins
 
 # partconf
 d-i/source/partconf/debian/partconf-*/* .
 
 # partman
 d-i/source/partman-*/debian/partman-*/* .
-ubiquity/components/ubi-partman.py usr/lib/ubiquity/plugins
 ubiquity/components/partman_commit.py usr/lib/ubiquity/ubiquity/components
 
 # preseed
 d-i/source/preseed/preseed_command bin
 
-# tasksel
-ubiquity/components/ubi-tasks.py usr/lib/ubiquity/plugins
-
 # tzsetup
 d-i/source/tzsetup/debian/tzmap usr/lib/ubiquity/tzsetup
 d-i/source/tzsetup/tzsetup usr/lib/ubiquity/tzsetup
-ubiquity/components/ubi-timezone.py usr/lib/ubiquity/plugins
 
 # user-setup
 d-i/source/user-setup/functions.sh usr/lib/ubiquity/user-setup
 d-i/source/user-setup/reserved-usernames usr/lib/ubiquity/user-setup
-ubiquity/components/ubi-usersetup.py usr/lib/ubiquity/plugins
 
 # migration-assistant
 d-i/source/migration-assistant/ma-script-utils usr/share/migration-assistant
@@ -111,4 +102,3 @@
 d-i/source/migration-assistant/ma-search-users usr/lib/ubiquity/migration-assistant
 d-i/source/migration-assistant/ma-search-items usr/lib/ubiquity/migration-assistant
 d-i/source/migration-assistant/ma-import usr/lib/ubiquity/migration-assistant
-ubiquity/components/ubi-migrationassistant.py usr/lib/ubiquity/plugins

=== added directory 'tests'
=== added file 'tests/run'
--- tests/run	1970-01-01 00:00:00 +0000
+++ tests/run	2010-04-08 13:58:29 +0000
@@ -0,0 +1,25 @@
+#!/bin/sh
+#make -C d-i update
+#make -C d-i build
+#make -C d-i install
+(cat d-i/templates; echo; po2debconf debian/ubiquity.templates; echo; po2debconf debian/ubiquity.templates-imported --podir=debian/imported-po) > tests/debconfdb
+#export DEBCONF_DB_REPLACE="File{tests/debconfdb.dat}"
+cat > tests/debconf.conf << EOF
+Config: configdb
+Templates: templatedb
+
+Name: configdb
+Driver: File
+Mode: 644
+Filename: tests/config.dat
+
+Name: templatedb
+Driver: File
+Mode: 644
+Filename: tests/templates.dat
+EOF
+export DEBCONF_SYSTEMRC=tests/debconf.conf
+debconf-loadtemplate ubiquity tests/debconfdb
+# For log-output
+export PATH="d-i/source/debian-installer-utils:$PATH"
+UBIQUITY_PLUGIN_PATH=ubiquity/plugins PIXMAPS=desktop UBIQUITY_GLADE=gui/gtk ./tests/run-gtk

=== added file 'tests/run-gtk'
--- tests/run-gtk	1970-01-01 00:00:00 +0000
+++ tests/run-gtk	2010-04-08 13:58:29 +0000
@@ -0,0 +1,25 @@
+#!/usr/bin/python
+
+import unittest
+import os, sys
+# Make sure we're working in the source tree.
+sys.path.insert(0, '.')
+#os.environ['UBIQUITY_PLUGIN_PATH'] = './ubiquity/components'
+from ubiquity.frontend import gtk_ui
+
+class FrontendTests(unittest.TestCase):
+    def setUp(self):
+        self.frontend = gtk_ui.Wizard('ubuntu')
+        # fail.
+        self.frontend.live_installer.hide()
+
+    def testReturnToPartitioner(self):
+        self.frontend.installing = True
+        self.frontend.return_to_partitioning()
+
+    def tearDown(self):
+        # Needed?
+        self.frontend.quit_main_loop()
+
+if __name__ == '__main__':
+    unittest.main()

=== modified file 'ubiquity/frontend/gtk_ui.py'
--- ubiquity/frontend/gtk_ui.py	2010-03-09 10:29:08 +0000
+++ ubiquity/frontend/gtk_ui.py	2010-04-08 13:58:29 +0000
@@ -68,10 +68,14 @@
 __pychecker__ = 'no-classattr'
 
 # Define global path
-PATH = '/usr/share/ubiquity'
+PATH = os.environ.get('UBIQUITY_PATH', False) or '/usr/share/ubiquity'
+
+# Define global pixmaps location
+PIXMAPS = os.environ.get('PIXMAPS', False) or '/usr/share/pixmaps'
 
 # Define ui path
-UIDIR = os.path.join(PATH, 'gtk')
+UIDIR = os.environ.get('UBIQUITY_GLADE', False) or os.path.join(PATH, 'gtk')
+os.environ['UBIQUITY_GLADE'] = UIDIR
 
 # Define locale path
 LOCALEDIR = "/usr/share/locale"
@@ -225,8 +229,8 @@
         # set custom language
         self.set_locales()
 
-        gtk.window_set_default_icon_from_file('/usr/share/pixmaps/'
-                                              'ubiquity.png')
+        gtk.window_set_default_icon_from_file(os.path.join(PIXMAPS,
+                                              'ubiquity.png'))
 
         # load the main interface
         self.builder.add_from_file('%s/ubiquity.ui' % UIDIR)

=== modified file 'ubiquity/plugin_manager.py'
--- ubiquity/plugin_manager.py	2010-02-23 23:29:50 +0000
+++ ubiquity/plugin_manager.py	2010-04-08 13:58:29 +0000
@@ -22,7 +22,8 @@
 import os
 import fnmatch
 
-PLUGIN_PATH = '/usr/lib/ubiquity/plugins'
+PLUGIN_PATH = (os.environ.get('UBIQUITY_PLUGIN_PATH', False)
+               or '/usr/lib/ubiquity/plugins')
 
 def load_plugins():
     modules = []

=== added directory 'ubiquity/plugins'
=== renamed file 'ubiquity/components/ubi-console-setup.py' => 'ubiquity/plugins/ubi-console-setup.py'
--- ubiquity/components/ubi-console-setup.py	2010-03-08 10:55:16 +0000
+++ ubiquity/plugins/ubi-console-setup.py	2010-04-08 13:58:29 +0000
@@ -42,7 +42,7 @@
             import gtk
             builder = gtk.Builder()
             self.controller.add_builder(builder)
-            builder.add_from_file('/usr/share/ubiquity/gtk/stepKeyboardConf.ui')
+            builder.add_from_file(os.path.join(os.environ['UBIQUITY_GLADE'], 'stepKeyboardConf.ui'))
             builder.connect_signals(self)
             self.page = builder.get_object('stepKeyboardConf')
             self.suggested_keymap = builder.get_object('suggested_keymap')

=== renamed file 'ubiquity/components/ubi-language.py' => 'ubiquity/plugins/ubi-language.py'
--- ubiquity/components/ubi-language.py	2010-03-12 23:50:50 +0000
+++ ubiquity/plugins/ubi-language.py	2010-04-08 13:58:29 +0000
@@ -68,7 +68,7 @@
         try:
             import gtk
             builder = gtk.Builder()
-            builder.add_from_file('/usr/share/ubiquity/gtk/%s' % ui_file)
+            builder.add_from_file(os.path.join(os.environ['UBIQUITY_GLADE'], ui_file))
             builder.connect_signals(self)
             self.controller.add_builder(builder)
             self.page = builder.get_object('stepLanguage')

=== renamed file 'ubiquity/components/ubi-migrationassistant.py' => 'ubiquity/plugins/ubi-migrationassistant.py'
--- ubiquity/components/ubi-migrationassistant.py	2010-02-24 11:46:35 +0000
+++ ubiquity/plugins/ubi-migrationassistant.py	2010-04-08 13:58:29 +0000
@@ -55,7 +55,7 @@
             import gtk
             builder = gtk.Builder()
             self.controller.add_builder(builder)
-            builder.add_from_file('/usr/share/ubiquity/gtk/stepMigrationAssistant.ui')
+            builder.add_from_file(os.path.join(os.environ['UBIQUITY_GLADE'], 'stepMigrationAssistant.ui'))
             builder.connect_signals(self)
             self.page = builder.get_object('stepMigrationAssistant')
             self.matreeview = builder.get_object('matreeview')

=== renamed file 'ubiquity/components/ubi-network.py' => 'ubiquity/plugins/ubi-network.py'
=== renamed file 'ubiquity/components/ubi-partman.py' => 'ubiquity/plugins/ubi-partman.py'
--- ubiquity/components/ubi-partman.py	2010-03-11 01:30:01 +0000
+++ ubiquity/plugins/ubi-partman.py	2010-04-08 13:58:29 +0000
@@ -74,8 +74,8 @@
             from ubiquity import segmented_bar
             builder = gtk.Builder()
             self.controller.add_builder(builder)
-            builder.add_from_file('/usr/share/ubiquity/gtk/stepPartAuto.ui')
-            builder.add_from_file('/usr/share/ubiquity/gtk/stepPartAdvanced.ui')
+            builder.add_from_file(os.path.join(os.environ['UBIQUITY_GLADE'], 'stepPartAuto.ui'))
+            builder.add_from_file(os.path.join(os.environ['UBIQUITY_GLADE'], 'stepPartAdvanced.ui'))
             builder.connect_signals(self)
             self.page = builder.get_object('stepPartAuto')
             self.page_advanced = builder.get_object('stepPartAdvanced')

=== renamed file 'ubiquity/components/ubi-summary.py' => 'ubiquity/plugins/ubi-summary.py'
--- ubiquity/components/ubi-summary.py	2010-02-21 15:28:33 +0000
+++ ubiquity/plugins/ubi-summary.py	2010-04-08 13:58:29 +0000
@@ -57,7 +57,7 @@
         import gtk
         builder = gtk.Builder()
         controller.add_builder(builder)
-        builder.add_from_file('/usr/share/ubiquity/gtk/stepReady.ui')
+        builder.add_from_file(os.path.join(os.environ['UBIQUITY_GLADE'], 'stepReady.ui'))
         builder.connect_signals(self)
         self.page = builder.get_object('stepReady')
         self.ready_text = builder.get_object('ready_text')

=== renamed file 'ubiquity/components/ubi-tasks.py' => 'ubiquity/plugins/ubi-tasks.py'
=== renamed file 'ubiquity/components/ubi-timezone.py' => 'ubiquity/plugins/ubi-timezone.py'
--- ubiquity/components/ubi-timezone.py	2010-02-11 15:38:01 +0000
+++ ubiquity/plugins/ubi-timezone.py	2010-04-08 13:58:29 +0000
@@ -39,7 +39,7 @@
             import gtk
             builder = gtk.Builder()
             self.controller.add_builder(builder)
-            builder.add_from_file('/usr/share/ubiquity/gtk/stepLocation.ui')
+            builder.add_from_file(os.path.join(os.environ['UBIQUITY_GLADE'], 'stepLocation.ui'))
             builder.connect_signals(self)
             self.page = builder.get_object('stepLocation')
             self.region_combo = builder.get_object('timezone_zone_combo')

=== renamed file 'ubiquity/components/ubi-usersetup.py' => 'ubiquity/plugins/ubi-usersetup.py'
--- ubiquity/components/ubi-usersetup.py	2010-03-09 10:41:43 +0000
+++ ubiquity/plugins/ubi-usersetup.py	2010-04-08 13:58:29 +0000
@@ -143,7 +143,7 @@
         import gtk
         builder = gtk.Builder()
         self.controller.add_builder(builder)
-        builder.add_from_file('/usr/share/ubiquity/gtk/stepUserInfo.ui')
+        builder.add_from_file(os.path.join(os.environ['UBIQUITY_GLADE'], 'stepUserInfo.ui'))
         builder.connect_signals(self)
         self.page = builder.get_object('stepUserInfo')
         self.username = builder.get_object('username')

